---
title: 'RTCIceTransport: gatheringstatechange event'
slug: Web/API/RTCIceTransport/gatheringstatechange_event
tags:
  - Connection
  - Connectivity
  - Gathering
  - ICE
  - Negotiation
  - RTCIceTransport
  - Reference
  - Transport
  - WebRTC
  - WebRTC API
  - events
  - gatheringSstate
  - gatheringstatechange
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">A <strong><code>gatheringstatechange</code></strong> event is sent to an {{domxref("RTCIceTransport")}} when its {{Glossary("ICE")}} candidate gathering state changes.</span> The gathering state, whose actual status can be found in the transport object's {{domxref("RTCIceTransport.gatheringState", "gatheringState")}} property, indicates whether or not the ICE agent has begun gathering candidates, and if so, if it has finished doing so.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{DOMxRef("Event")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{DOMxRef("RTCIceTransport.ongatheringstatechange", "ongatheringstatechange")}}</td>
  </tr>
 </tbody>
</table>

<p>The key difference between <code>gatheringstatechange</code> and {{domxref("RTCPeerConnection.icegatheringstatechange_event", "icegatheringstatechange")}} is that the latter represents the overall state of the connection including every {{domxref("RTCIceTransport")}} used by every {{domxref("RTCRtpSender")}} and every {{domxref("RTCRtpReceiver")}} on the entire connection. In contrast, <code>gatheringstatechange</code> represents changes to the candidate gathering state for a single transport.</p>

<h2 id="Examples">Examples</h2>

<p>This example creates a handler for <code>gatheringstatechange</code> events on each {{domxref("RTCRtpSender")}} associated with a given {{domxref("RTCPeerConnection")}}. Here, the {{domxref("EventTarget.addEventListener", "addEventListener()")}} method is called to add a listener for <code>gatheringstatechange</code> events:</p>

<pre class="brush: js">pc.getSenders().forEach(sender =&gt; {
  sender.transport.iceTransport.addEventListener("gatheringstatechange", ev =&gt; {
  let transport = ev.target;

  if (transport.gatheringState === "complete") {
    /* this transport has finished gathering candidates,
       but others may still be working on it */
  }
}, false);</pre>

<p>Likewise, you can use the {{domxref("RTCIceTransport.ongatheringstatechange", "ongatheringstatechange")}} event handler property:</p>

<pre class="brush: js">pc.getSenders().forEach(sender =&gt; {
  sender.transport.iceTransport.ongatheringstatechange = ev =&gt; {
    let transport = ev.target;

    if (transport.gatheringState === "complete") {
      /* this transport has finished gathering candidates,
         but others may still be working on it */
    }
  };
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#event-icetransport-gatheringstatechange', 'gatheringstatechange') }}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCIceTransport.gatheringstatechange_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Connectivity">WebRTC connectivity</a></li>
 <li>{{domxref("RTCIceTransport.ongatheringstatechange")}}</li>
</ul>

<h3 id="Related_RTCIceTransport_events">Related RTCIceTransport events</h3>

<ul>
 <li>{{event("statechange")}}</li>
 <li>{{event("selectedcandidatepairchange")}}</li>
</ul>

<h3 id="Related_RTCPeerConnection_events">Related RTCPeerConnection events</h3>

<ul>
 <li>{{event("negotiationneeded")}}</li>
 <li>{{event("signalingstatechange")}}</li>
 <li>{{event("iceconnectionstatechange")}}</li>
 <li>{{event("icegatheringstatechange")}}</li>
 <li>{{event("connectionstatechange")}}</li>
</ul>

